'''
Main program for

Aggregate subgradient method for nonsmooth DC optimization.

Created on 13 Jan 2020

@author: Napsu Karmitsa

Reference:
A. Bagirov, S. Taheri, K. Joki, N. Karmitsa, M.M. Mäkelä, 
"Aggregate subgradient method for nonsmooth DC optimization", Optimization Letters, 
to appear, 2020.

Acknowledgement:
The work was financially supported by Academy of Finland (Project No. 289500). 

'''
# Load library
import numpy as np
# import time
import time 

# Import initiaization by user 
import user_init

# Import Aggregate subgradient method 
import aggsub

# Starting time
usedtime = time.clock()

# Initialization of the method (Data and Step 0).
# print user_init.init.__doc__ # Prints documentation at the beginning of function
n,x,eps,mit,tau,delta,sig1,sig2,c1,c2 = user_init.init()

# Call aggregate subgradient method.
#print aggsub.aggsub.__doc__ #This works ok, but if we call aggsub often...
aggsu = aggsub.aggsub
#print aggsu.__doc__ # Prints documentation at the beginning of function
x,f,nit,nf,ng = aggsu(x,eps,mit,tau,sig1,delta,sig2,c1,c2)
    
# Results:
print('\nResults:\n')    
print "nit = ",nit
print "nf  = ",nf
print "ng  = ",ng
print "x   = ",x
print('f   =  %4.6e' %f)

# CPU time used
usedtime = time.clock() - usedtime
print('CPU time = %4.4f' %usedtime)
